]> git.ipfire.org Git - thirdparty/git.git/blame - t/test-lib.sh
Fix snapshot link in tree view
[thirdparty/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5
6# For repeatability, reset the environment to known value.
7LANG=C
899460f3 8LC_ALL=C
d9bdd39e 9PAGER=cat
e1970ce4 10TZ=UTC
899460f3 11export LANG LC_ALL PAGER TZ
8ff99e74
EW
12EDITOR=:
13VISUAL=:
e1970ce4
JH
14unset AUTHOR_DATE
15unset AUTHOR_EMAIL
16unset AUTHOR_NAME
17unset COMMIT_AUTHOR_EMAIL
18unset COMMIT_AUTHOR_NAME
19unset GIT_ALTERNATE_OBJECT_DIRECTORIES
20unset GIT_AUTHOR_DATE
29e55cd5
JH
21GIT_AUTHOR_EMAIL=author@example.com
22GIT_AUTHOR_NAME='A U Thor'
6677c466 23unset GIT_COMMITTER_DATE
29e55cd5
JH
24GIT_COMMITTER_EMAIL=committer@example.com
25GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
26unset GIT_DIFF_OPTS
27unset GIT_DIR
28unset GIT_EXTERNAL_DIFF
29unset GIT_INDEX_FILE
30unset GIT_OBJECT_DIRECTORY
31unset SHA1_FILE_DIRECTORIES
32unset SHA1_FILE_DIRECTORY
29e55cd5
JH
33export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
34export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
8ff99e74 35export EDITOR VISUAL
e1970ce4 36
6ce4e61f
CC
37case $(echo $GIT_TRACE |tr [A-Z] [a-z]) in
38 1|2|true)
39 echo "* warning: Some tests will not work if GIT_TRACE" \
40 "is set as to trace on STDERR ! *"
41 echo "* warning: Please set GIT_TRACE to something" \
42 "other than 1, 2 or true ! *"
43 ;;
44esac
45
e1970ce4
JH
46# Each test should start with something like this, after copyright notices:
47#
48# test_description='Description of this test...
49# This test checks if command xyzzy does the right thing...
50# '
51# . ./test-lib.sh
52
53error () {
54 echo "* error: $*"
41184273 55 trap - exit
e1970ce4
JH
56 exit 1
57}
58
59say () {
60 echo "* $*"
61}
62
63test "${test_description}" != "" ||
64error "Test script did not set test_description."
65
66while test "$#" -ne 0
67do
68 case "$1" in
69 -d|--d|--de|--deb|--debu|--debug)
70 debug=t; shift ;;
886856ab
JH
71 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
72 immediate=t; shift ;;
e1970ce4
JH
73 -h|--h|--he|--hel|--help)
74 echo "$test_description"
75 exit 0 ;;
76 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
77 verbose=t; shift ;;
abb7c7b3
JS
78 --no-python)
79 no_python=t; shift ;;
e1970ce4
JH
80 *)
81 break ;;
82 esac
83done
84
4d9d62fa 85exec 5>&1
e1970ce4
JH
86if test "$verbose" = "t"
87then
88 exec 4>&2 3>&1
89else
90 exec 4>/dev/null 3>/dev/null
91fi
92
93test_failure=0
94test_count=0
95
41184273
PR
96trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
97
e1970ce4 98
886856ab
JH
99# You are not expected to call test_ok_ and test_failure_ directly, use
100# the text_expect_* functions instead.
101
102test_ok_ () {
e1970ce4 103 test_count=$(expr "$test_count" + 1)
94e8afa2 104 say " ok $test_count: $@"
e1970ce4
JH
105}
106
886856ab 107test_failure_ () {
e1970ce4
JH
108 test_count=$(expr "$test_count" + 1)
109 test_failure=$(expr "$test_failure" + 1);
bf0dd8a8
JH
110 say "FAIL $test_count: $1"
111 shift
112 echo "$@" | sed -e 's/^/ /'
41184273 113 test "$immediate" = "" || { trap - exit; exit 1; }
886856ab
JH
114}
115
116
117test_debug () {
8e832ebc 118 test "$debug" = "" || eval "$1"
e1970ce4
JH
119}
120
4d9d62fa 121test_run_ () {
4d9d62fa
PR
122 eval >&3 2>&4 "$1"
123 eval_ret="$?"
4d9d62fa
PR
124 return 0
125}
126
e1970ce4 127test_expect_failure () {
8e832ebc 128 test "$#" = 2 ||
e1970ce4
JH
129 error "bug in the test script: not 2 parameters to test-expect-failure"
130 say >&3 "expecting failure: $2"
4d9d62fa
PR
131 test_run_ "$2"
132 if [ "$?" = 0 -a "$eval_ret" != 0 ]
e1970ce4 133 then
886856ab 134 test_ok_ "$1"
4d9d62fa
PR
135 else
136 test_failure_ "$@"
e1970ce4
JH
137 fi
138}
139
140test_expect_success () {
8e832ebc 141 test "$#" = 2 ||
e1970ce4
JH
142 error "bug in the test script: not 2 parameters to test-expect-success"
143 say >&3 "expecting success: $2"
4d9d62fa
PR
144 test_run_ "$2"
145 if [ "$?" = 0 -a "$eval_ret" = 0 ]
e1970ce4 146 then
886856ab 147 test_ok_ "$1"
e1970ce4 148 else
886856ab 149 test_failure_ "$@"
e1970ce4
JH
150 fi
151}
152
d3bfdb75
FK
153test_expect_code () {
154 test "$#" = 3 ||
155 error "bug in the test script: not 3 parameters to test-expect-code"
156 say >&3 "expecting exit code $1: $3"
157 test_run_ "$3"
158 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
159 then
160 test_ok_ "$2"
161 else
162 test_failure_ "$@"
163 fi
164}
165
eedf8f97
CW
166# Most tests can use the created repository, but some amy need to create more.
167# Usage: test_create_repo <directory>
168test_create_repo () {
169 test "$#" = 1 ||
170 error "bug in the test script: not 1 parameter to test-create-repo"
171 owd=`pwd`
172 repo="$1"
173 mkdir "$repo"
174 cd "$repo" || error "Cannot setup test environment"
175 "$GIT_EXEC_PATH/git" init-db --template=$GIT_EXEC_PATH/templates/blt/ 2>/dev/null ||
176 error "cannot run git init-db -- have you built things yet?"
177 mv .git/hooks .git/hooks-disabled
178 cd "$owd"
179}
180
e1970ce4 181test_done () {
41184273 182 trap - exit
e1970ce4 183 case "$test_failure" in
10b94e28 184 0)
e1970ce4
JH
185 # We could:
186 # cd .. && rm -fr trash
187 # but that means we forbid any tests that use their own
188 # subdirectory from calling test_done without coming back
189 # to where they started from.
190 # The Makefile provided will clean this test area so
191 # we will leave things as they are.
192
193 say "passed all $test_count test(s)"
194 exit 0 ;;
195
196 *)
197 say "failed $test_failure among $test_count test(s)"
198 exit 1 ;;
199
200 esac
201}
202
203# Test the binaries we have just built. The tests are kept in
204# t/ subdirectory and are run in trash subdirectory.
205PATH=$(pwd)/..:$PATH
a0fa2a10 206GIT_EXEC_PATH=$(pwd)/..
49ccb087
JH
207export PATH GIT_EXEC_PATH
208
209# Similarly use ../compat/subprocess.py if our python does not
210# have subprocess.py on its own.
211PYTHON=`sed -e '1{
212 s/^#!//
213 q
eea42069
JH
214}' ../git-merge-recursive` || {
215 error "You haven't built things yet, have you?"
216}
49ccb087
JH
217"$PYTHON" -c 'import subprocess' 2>/dev/null || {
218 PYTHONPATH=$(pwd)/../compat
219 export PYTHONPATH
220}
eea42069
JH
221test -d ../templates/blt || {
222 error "You haven't built things yet, have you?"
223}
e1970ce4
JH
224
225# Test repository
226test=trash
227rm -fr "$test"
eedf8f97
CW
228test_create_repo $test
229cd "$test"